require "Apollo"
require "GameLib"
 
local LinkMeHarder = {} 

function LinkMeHarder:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 
    return o
end

function LinkMeHarder:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		"Character",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 
function LinkMeHarder:OnLoad()
	self.xmlDoc = XmlDoc.CreateFromFile("LinkMeHarder.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
end

function LinkMeHarder:OnDocLoaded()
	Apollo.RegisterEventHandler("CharacterPost", "OnCharacterPost", self)
	
	AddonCharacter = Apollo.GetAddon("Character")
	AddonCharacter.OriginalOnDocumentReady = AddonCharacter.OnDocumentReady
	
	AddonCharacter.OnDocumentReady = function(...)
		AddonCharacter:OriginalOnDocumentReady(...)
		Event_FireGenericEvent("CharacterPost")
	end
end

function LinkMeHarder:OnCharacterPost()
	self.characterAddon = Apollo.GetAddon("Character")
	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.wndMain = Apollo.LoadForm(self.xmlDoc, "LinkButtons", self.characterAddon.wndCharacter:FindChild("Left"), self)
		if self.wndMain == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
		self.wndMain:Show(true, true)	
	end
end

function LinkMeHarder:LinkItem( wndHandler, wndControl, eMouseButton )
	local equipped = GameLib.GetPlayerUnit():GetEquippedItems() 
	if not equipped then return end
	
	local item = -1
	
	if wndControl:GetName() == "bChest" 		then item = 0 end
	if wndControl:GetName() == "bLegs" 			then item = 1 end
	if wndControl:GetName() == "bHead" 			then item = 2 end
	if wndControl:GetName() == "bShoulder" 		then item = 3 end
	if wndControl:GetName() == "bFeet" 			then item = 4 end
	if wndControl:GetName() == "bHands" 		then item = 5 end
	if wndControl:GetName() == "bAttachment" 	then item = 7 end
	if wndControl:GetName() == "bSystem" 		then item = 8 end
	if wndControl:GetName() == "bImplant" 		then item = 10 end
	if wndControl:GetName() == "bGadget" 		then item = 11 end
	if wndControl:GetName() == "bShield" 		then item = 15 end
	if wndControl:GetName() == "bWeapon" 		then item = 16 end
	
	if item == -1 then return end
	
	for _, iteminfo in pairs( equipped ) do
		local inventoryid = iteminfo:GetInventoryId()
		if inventoryid  == item then
			Event_FireGenericEvent( "ItemLink" , iteminfo )
		end
	end
end

local LinkMeHarderInst = LinkMeHarder:new()
LinkMeHarderInst:Init()
